Foxit PDF RDK

Public Member Functions | Static Public Attributes | List of all members
PDFDoc Class Reference
Inheritance diagram for PDFDoc:

## Public Member Functions
| AddHeaderFooter (headerfooter)
| Add new header-footer. More...
| AddIndirectObject (pdf_object)
| Add a PDF object to current PDF document, to be an indirect object. More...
| AddPageFromTemplate (template_name)
| Adds a new PDF page to document, from a named template. More...
| AddPagingSealSignature (page_range, width, height)
| Add a paging seal signature to document by page range. More...
| AddTableOfContents (table_of_contents_config)
| Insert page(s) as the table of contents to the front of current PDF document. More...
| AddTableOfContents (title, bookmark_level_array)
| Insert page(s) as the table of contents to the front of current PDF document. More...
| CheckPassword (password)
| Check the type of a specified password. More...
| ClearRenderCache ()
| Clear the cache used during rendering, to reduce the memory usage. More...
| constructor ()
| Constructor. More...
| constructor (buffer)
| Constructor, from a memory buffer. More...
| constructor (file_read, is_async)
| Constructor, with a file read callback object. More...
| constructor (path)
| Constructor, from an existing PDF file path. More...
| CreateDSS ()
| Create DSS information in current PDF document. More...
| CreateRootBookmark ()
| Create new bookmark root node. More...
| DeleteIndirectObject (object_number)
| Delete an indirect object by indirect object number. More...
| DoJSOpenAction ()
| Perform JavaScript actions when the document is opened. More...
< boolean > | ExportAnnotToFDF (pdf_annot, fdf_doc)
| Export specified annotation to a FDF/XFDF document. More...
| ExportFormFieldsToFDF (field_array, is_include, fdf_doc)
| Export specified form fields to a FDF/XFDF document. More...
< boolean > | ExportToFDF (fdf_doc, types, page_range)
| Export form fields and annotations to a FDF/XFDF document. More...
| GetBookmarkLevelDepth ()
| Get bookmark level depth. More...
| GetCatalog ()
| Get the catalog dictionary. More...
| GetCertificateEncryptData ()
| Get encrypt data of certificate encryption. More...
| GetCustomEncryptData ()
| Get encrypt data of custom encryption. More...
< PDFPage > | GetDisplayMode ()
| Get the display mode. More...
| GetDRMEncryptData ()
| Get encrypt data of Foxit DRM encryption. More...
| GetEditableHeaderFooter ()
| Get the editable header footer object. More...
< PageBasicInfo > | GetEmbeddedFontData ()
| Get embedded font data. More...
| GetEncryptDict ()
| Get the encrypt dictionary. More...
| GetEncryptionType ()
| Get the encryption type. More...
| GetFileSize ()
| Get file size. More...
| GetFileVersion ()
| Get PDF file version stored in PDF header section. More...
| GetFirstAvailPageIndex ()
| Get the page index of the fist available page. More...
| GetFont (index)
| Get a font by index. More...
| GetFontCount ()
| Count all the PDF fonts used in current PDF document. More...
| GetHeader ()
| Get PDF header identifying the version of the PDF specification to which the file conforms. More...
| GetIndirectObject (object_number)
| Get an indirect object by indirect object number. More...
| GetInfo ()
| Get the information dictionary. More...
| GetOpenAction ()
| Get the action to be performed when the document is opened. More...
| GetPage (index)
| Get a PDF page by index. More...
| GetPageBasicInfo (index)
| Get the basic information of a page specified by index. More...
| GetPageBasicInfoAsync (index)
| Asynchronously get the basic information of a page specified by its index.. More...
| GetPageCount ()
| Get the count of pages. More...
| GetPagesDict ()
| Get the dictionary of "Pages". More...
| GetPageText (page_index)
| Get the specified PDF page text which the text is in display order. More...
| GetPasswordType ()
| Get the type of current used password. More...
| GetPayLoadData ()
| Get payload data if current document's wrapper type is PDFDoc.e_WrapperPDFV2. More...
| GetReadingBookmark (index)
| Get a reading bookmark by index. More...
| GetReadingBookmarkCount ()
| Get the count of reading bookmarks. More...
| GetRMSEncryptData ()
| Get encrypt data of RMS encryption. More...
| GetRootBookmark ()
| Get bookmark root node. More...
| GetSecurityHandler ()
| Get current PDF security handler of current document. More...
| GetSignature (index)
| Get a signature by index. More...
| GetSignatureCount ()
| Get the count of signature. More...
| GetStdEncryptData ()
| Get encrypt data of standard encryption (known as password encryption). More...
| GetTrailer ()
| Get the trailer dictionary. More...
| GetUserPassword (owner_password)
| Get the user password based on owner password. More...
| GetUserPermissions ()
| Get user access permissions. More...
| GetWrapperData ()
| Get wrapper data if current document's wrapper type is PDFDoc.e_WrapperFoxit. More...
| GetWrapperOffset ()
| Get wrapper offset if current document's wrapper type is PDFDoc.e_WrapperFoxit. More...
| GetWrapperType ()
| Get Wrapper type. More...
| HasForm ()
| Check whether current PDF document has interactive form (also known as AcroForm). More...
| HasHeaderFooter ()
| Check whether current document has header-footer. More...
| HasLayer ()
| Check whether current PDF document has layer (known as "Optional content group" in <PDF reference 1.7>) or not. More...
| HidePageTemplate (template_name)
| Hide a named page. More...
| ImportFromFDF (fdf_doc, types, page_range)
| Import form fields and annotations from a FDF/XFDF document. More...
| InsertDocument (dest_index, src_doc, options)
| Insert another PDF document to the specified location of current PDF document. More...
| InsertPage (index, size)
| Insert a new blank PDF page to document, by index. More...
| InsertPage (index, width, height)
| Insert a new blank PDF page to document, by index. More...
| InsertReadingBookmark (reading_bookmark_index, title, dest_page_index)
| Insert a reading bookmark to current PDF document. More...
| IsEmpty ()
| Check whether current object is empty or not. More...
| IsEncrypted ()
| Check whether current document is an encrypted file or not. More...
| IsLinearized ()
| Check if current PDF document is a linearized file. More...
| IsOwnerPassword (password)
| Check if input password is the owner password of current PDF document. More...
| IsPortfolio ()
| Check whether current PDF document is a portfolio file or not. More...
| IsTaggedPDF ()
| Check if current PDF document is a Tagged PDF file. More...
| IsUserPassword (password)
| Check if input password is the user password of current PDF document. More...
| IsWrapper ()
| Check whether current document is a wrapper file or not. More...
| IsXFA ()
| Check whether current PDF document is an XFA document. More...
| Load (password)
| Load current document content by using a specified password. More...
| LoadW (password)
| Load current document content by using a specified password. More...
| MovePagesTo (page_range, dest_index)
| Move one or more pages (specified by index) to a new index position. More...
| MovePageTo (page, dest_index)
| Move a specified page to a new index position. More...
| RemoveAllHeaderFooters ()
| Remove all header-footers. More...
| RemoveBookmark (bookmark)
| Remove a specified bookmark. More...
| RemoveOpenAction ()
| Remove the action to be performed when the document is opened. More...
| RemovePage (index)
| Remove a PDF page by page index. More...
| RemovePage (page)
| Remove a specified PDF page. More...
| RemoveReadingBookmark (reading_bookmark)
| Remove a reading bookmark from current PDF document. More...
| RemoveSecurity ()
| Remove the security handler from current document, so that the later saved document will be unencrypted. More...
| RemoveSignature (signature)
| Remove a signature. More...
| SaveAs (file_path, save_flags)
| Save current PDF document as another PDF file. More...
| SaveAsWrapperFile (file_path, wrapper_data, user_permissions, owner_password)
| Save current PDF document as a wrapper file. More...
| SetCacheFile (file_stream, is_own_file_stream)
| Set cache file (represented by a file stream) to current PDF document. More...
| SetDisplayMode (display_mode)
| Set the display mode. More...
| SetFileVersion (version)
| Set the PDF file version which will be stored in PDF header section of the saved PDF file. More...
| SetOpenAction (action)
| Set the action to be performed when the document is opened. More...
| SetSecurityHandler (handler)
| Set a PDF security handler for encryption, such as standard encryption(password), certificate encryption, and so on. More...
| StartAddTiledWatermark (page, settings, page_range, pause)
| Add page type tiled watermark to PDF pages. More...
| StartAddTiledWatermark (src_img_file_path, settings, page_range, pause)
| Add image type tiled watermark to PDF pages by image path. More...
| StartAddTiledWatermark (src_img_stream, settings, page_range, pause)
| Add image type tiled watermark to PDF pages by image stream. More...
| StartAddTiledWatermark (text, settings, page_range, pause)
| Add text type tiled watermark to PDF pages. More...
| StartEmbedAllFonts (pause)
| Start to convert all un-embeded fonts to embeded fonts. More...
< Progressive > | StartExtractPages (file, options, page_range, pause)
| Start to extract pages from current PDF document. More...
< Progressive > | StartExtractPages (file_path, options, page_range, pause)
| Start to extract pages from current PDF document. More...
| StartGetPayloadFile (payload_file, pause)
| Start to get payload file. More...
< Progressive > | StartImportPages (dest_index, src_doc, flags, layer_name, page_range, pause)
| Start to import pages from another PDF document (via PDF document object). More...
| StartImportPagesFromFilePath (dest_index, src_file_path, password, flags, layer_name, page_range, pause)
| Start to import pages from another PDF document (via file path). More...
| StartLoad (password, is_cache_stream, pause)
| Start to loading current document content by using a specified password. More...
| StartLoadW (password, is_cache_stream, pause)
| Start to loading current document content by using a specified password. More...
| StartRecognizeForm (pause)
| Start to recognize form in current PDF document. More...
< Progressive > | StartSaveAs (file, save_flags, pause)
| Start to save current PDF document as another PDF file. More...
| StartSaveAs (file_path, save_flags, pause)
| Start to save current PDF document as another PDF file. More...
| StartSaveAsPayloadFile (file_path, payload_file_path, crypto_filter, description, version, ave_flags, pause)
| Start to save current PDF document as a wrapper document with a payload document (defined in PDF 2.0). More...
| UpdateHeaderFooter (headerfooter)
| Update header-footer. More...
Public Member Functions inherited from NativeObjectWrapper
| constructor (r)
| GetPointerAsNumber ()

## Static Public Attributes
static | e_Annots
| If set, annotations (except link annotations) are to imported from or exported to FDF/XFDF document.
static | e_DisplayFullScreen
| When document is opened, full-screen mode, with no menu bar, window controls, or any other windows are visible.
static | e_DisplayUseAttachment
| When document is opened, attachment panels are visible.
static | e_DisplayUseNone
| Enumeration for display mode which specifies how the document should be displayed when opened. More...
static | e_DisplayUseOC
| When document is opened, optional content group panels are visible.
static | e_DisplayUseOutlines
| When document is opened, document outlines (bookmarks) are visible.
static | e_DisplayUseThumbs
| When document is opened, thumbnail images are visible.
static | e_EncryptCDRM
| (Reserved, currently, this value is not used.) Encryption type: Foxit connected PDF DRM encryption.
static | e_EncryptCertificate
| Encryption type: digital certificate encryption.
static | e_EncryptCustom
| Encryption type: customized encryption.
static | e_EncryptFoxitDRM
| Encryption type: Foxit DRM encryption.
static | e_EncryptNone
| No encryption pattern.
static | e_EncryptPassword
| Encryption type: password, which is the standard encryption.
static | e_EncryptRMS
| Encryption type: Microsoft RMS encryption.
static | e_EncryptUnknown
| Enumeration for encryption type. More...
static | e_ExtractPagesOptionAnnotation
| Enumeration for options used for extracting pages. More...
static | e_ExtractPagesOptionAttachFiles
| If set, that means attachment files will be extracted as well.
static | e_ExtractPagesOptionJavascript
| If set, that means Javascript will be extracted as well.
static | e_ExtractPagesOptionObjectStream
| If set, that means to use PDFDoc.e_SaveFlagXRefStream saving flag for the result file in order to reduce the size of result file.
static | e_ExtractPagesOptionOCProperties
| If set, that means OCProperties will be extracted as well.
static | e_ExtractPagesOptionStructureTree
| If set, that means structure tree will be extracted as well.
static | e_Forms
| Enumeration for data type used to decide which object(s) will be imported from or exported to FDF/XFDF document. More...
static | e_ImportFlagNormal
| Enumeration for flags used for importing pages. More...
static | e_ImportFlagShareStream
| Import pages without cloning stream objects into memory. More...
static | e_ImportFlagWithLayers
| Import pages with layers.
static | e_InsertDocOptionAttachments
| Enumeration for options used for inserting a PDF document to another. More...
static | e_Links
| (Reserved, not supported yet) If set, only link annotations are to imported from or exported to XFDF document.
static | e_PermAnnotForm
| Operate text annotations and fill in interactive form fields. (Bit 6 in permission value) More...
static | e_PermAssemble
| Assemble PDF document. (Bit 11 in permission value) More...
static | e_PermExtract
| Extract PDF contents. (Bit 5 in permission value) More...
static | e_PermExtractAccess
| Disabilities support. (Bit 10 in permission value) More...
static | e_PermFillForm
| Fill PDF form. (Bit 9 in permission value) More...
static | e_PermModify
| Modify PDF contents. (Bit 4 in permission value) More...
static | e_PermPrint
| Enumeration for user access permissions in a PDF document. More...
static | e_PermPrintHigh
| Print PDF document with higher qualities. (Bit 12 in permission value) More...
static | e_PwdInvalid
| Enumeration for the type of current used password in a PDF document. More...
static | e_PwdNoPassword
| No password is used in PDF document.
static | e_PwdOwner
| An owner password is used in PDF document.
static | e_PwdUser
| A user password is used in PDF document.
static | e_SaveFlagIncremental
| Save document incrementally. More...
static | e_SaveFlagLinearized
| Save document as a linearized file. More...
static | e_SaveFlagNoOriginal
| Save document without original data or unchanged objects. More...
static | e_SaveFlagNormal
| Enumeration for PDF document saving flags. More...
static | e_SaveFlagNoUpdatingMetadataDateTime
| Save document without updating metadata "ModDate" and "CreationDate". More...
static | e_SaveFlagRemoveRedundantObjects
| Save document with removing redundant PDF objects. More...
static | e_SaveFlagXRefStream
| Save document by using XRef stream. More...
static | e_WrapperFoxit
| Foxit wrapper document.
static | e_WrapperNone
| Enumeration for wrapper type. More...
static | e_WrapperPDFV2
| PDF 2.0 wrapper document.

## Detailed Description

A PDF document object can be constructed with an existing PDF file from file path, memory buffer, a custom implemented FileReaderCallback object and an input file stream. And then call function PDFDoc.Load or PDFDoc.StartLoad to load document content. This class offers functions to retrieve different part of a PDF document. For example:

- To retrieve pages, please use functions PDFDoc.GetPageCount and PDFDoc.GetPage.
- To retrieve bookmark, such as function PDFDoc.GetRootBookmark, PDFDoc.CreateRootBookmark, etc.
- To retrieve some document's dictionaries (in low-level), such as functions PDFDoc.GetCatalog, PDFDoc.GetTrailer, etc.
- To retrieve reading bookmark, such as functions PDFDoc.GetReadingBookmarkCount, PDFDoc.GetReadingBookmark, etc.
- To check if a PDF document has interactive form, please use function PDFDoc.HasForm.
- To check if a PDF document has header-footer, please use function PDFDoc.HasHeaderFooter. To modify header-footer, please refer to functions such as PDFDoc.AddHeaderFooter, PDFDoc.UpdateHeaderFooter, and PDFDoc.RemoveAllHeaderFooters.

This class also offers functions for features, such as saving current document as another PDF file, importing pages from another PDF file, setting security handler in order to save encrypted PDF file, and so on.
This class object can also be used to construct objects of other classes in order to access specified information in PDF document:

- To access form, please construct a Form object with PDF document object.
- To access additional actions, please construct an AdditionalAction object with PDF document object.
- To access viewer preferences information, please construct a DocViewerPrefs object with PDF document object.
- To access metadata information, please construct a Metadata object with PDF document object.
- To manage page labels information, please construct a PageLabels object with PDF document object.
- To search among a PDF file, please construct a TextSearch object with PDF document object.
- To access layers, please construct a LayerTree object with PDF document object. And to render layers, please constructor a LayerContext object with PDF document object.
- To construct a new FileSpec object.
- To manage associated files, please construct an AssociatedFiles object with PDF document object.
- To access name tree, please construct a PDFNameTree object with PDF document object. Specially, for EmbeddedFiles name tree, an Attachments object can be constructed with PDF document object, for convenient use.
- To do redaction, please construct a Redaction object with PDF document object.

See also
  Form
  AdditionalAction
  DocViewerPrefs
  Metadata
  PageLabels
  TextSearch
  LayerTree
  LayerContext
  FileSpec
  AssociatedFiles
  PDFNameTree
  Attachments
  Redaction

Examples
  /Users/ec2-user/gitlab-runner/builds/E-xKdhDo/0/foxit/sdk/mobile/gsdk-doc-auto-build/harmony_nodejs/input/Index.js.

## Member Function Documentation

## ◆ AddHeaderFooter()

PDFDoc.AddHeaderFooter | ( | headerfooter |  | ) |

Add new header-footer.

A PDF document can be added header-footer sereral times. When a new header-footer is added, the old ones will not be removed but be covered by the new one if the old ones appear in the same place as new one.

Parameters

  [in] | headerfooter | A valid header-footer object to be added to current document.

Returns
  None.

## ◆ AddIndirectObject()

PDFDoc.AddIndirectObject | ( | pdf_object |  | ) |

Add a PDF object to current PDF document, to be an indirect object.

- If input PDF object is a direct object (whose indirect object number is 0), this functions will change it to be an indirect object and add to PDF document. Then return the new indirect object number.
- If input PDF object is already an indirect object (whose indirect object number is above 0), this function will not add it into document again. The return value will be its own indirect object number.

Parameters

  [in] | pdf_object | A PDFObject object. It should not be null.

Returns
  The new indirect object number. It would be above 0.

## ◆ AddPageFromTemplate()

PDFDoc.AddPageFromTemplate | ( | template_name |  | ) |

Adds a new PDF page to document, from a named template.

There may exist hidden pages in a PDF document. Hidden pages are mapped to the names defined in the template name tree in the PDF document. This function can be used to add a hidden page to the end of the PDF document.
Class PDFNameTree (initialized with type PDFNameTree.e_Templates) can be used to determine which template names are available.
After a template has been added, the name will be moved to the document's pages name tree internally.

Parameters

  [in] | template_name | The name of a template, whose mapping hidden page will be added to the end of current PDF document. If the template name cannot be found, exception e_ErrParam will be thrown.

Returns
  A new PDF page object if input template name was found.

## ◆ AddPagingSealSignature()

PDFDoc.AddPagingSealSignature | ( | page_range | ,
|  | width | ,
|  | height |
| ) |  |

Add a paging seal signature to document by page range.

This function will add a signature to the first page of page_range.

Parameters

  [in] | page_range | A range object that specifies some pages. These pages will be added a signature. The valid page range: from 1 to count. count is returned by function PDFDoc.GetPageCount. If this range object is constructed by default constructor and not set any value, that means all the pages of current document will be added a signature. This function does not support a range with a single index or a document with a single page.
  [in] | width | The width of paging seal. The value will be used for setting rectangle of the signature on each page.
  [in] | height | The height of paging seal. The value will be used for setting rectangle of the signature on each page.

Returns
  A paging seal signature object.

## ◆ AddTableOfContents() [1/2]

PDFDoc.AddTableOfContents | ( | table_of_contents_config |  | ) |

Insert page(s) as the table of contents to the front of current PDF document.

If the current document does not have any bookmark, this function will do nothing.

Parameters

  [in] | table_of_contents_config | A table of contents configuration object which is used for the table of contents.

Returns
  None.

## ◆ AddTableOfContents() [2/2]

PDFDoc.AddTableOfContents | ( | title | ,
|  | bookmark_level_array |
| ) |  |

Insert page(s) as the table of contents to the front of current PDF document.

If the current document does not have any bookmark, this function will do nothing.

Parameters

  [in] | title | Title for the table of contents. If this is an empty string, the default value "Table of Contents" will be used.
  [in] | bookmark_level_array | A bookmark level array which is used to specify bookmarks to be used to generate "Table of Contents". For each element in input array, valid range: from 1 to (depth). depth is returned by function PDFDoc.GetBookmarkLevelDepth. If input array is an empty array, that means all bookmarks are used to generate "Table of Contents".

Returns
  None.

## ◆ CheckPassword()

PDFDoc.CheckPassword | ( | password |  | ) |

Check the type of a specified password.

This function can be used to check the type of any password string, including the password string used for loading document content.
Some PDF documents may have user password and owner password at the same time and these two passwords are same. But current function can only return one type for such password. In this case, functions PDFDoc.IsUserPassword and PDFDoc.IsOwnerPassword can help to do more check.

Parameters

  [in] | password | A password string to be detected.

Returns
  Password type. Please refer to values starting from PDFDoc.e_PwdInvalid and this would be one of these values.

## ◆ ClearRenderCache()

PDFDoc.ClearRenderCache | ( |  | ) |

Clear the cache used during rendering, to reduce the memory usage.

Returns
  None.

## ◆ constructor() [1/4]

PDFDoc.constructor | ( |  | ) |

Constructor.

This constructor is to construct a new PDF document (without any data). The file version value would be 17 (as PDF version 1.7) by default.

## ◆ constructor() [2/4]

PDFDoc.constructor | ( | buffer |  | ) |

Constructor, from a memory buffer.

After constructing such a PDF document object, please ensure the document object has been loaded before using most functions in class PDFDoc.

Parameters

  [in] | buffer | A memory buffer, containing the serialized document. The PDF document data should be fully loaded in this memory buffer. It should not be null.

## ◆ constructor() [3/4]

PDFDoc.constructor | ( | file_read | ,
|  | is_async |
| ) |  |

Constructor, with a file read callback object.

After constructing such a PDF document object, please ensure the document object has been loaded before using most functions in class PDFDoc.

Parameters

  [in] | file_read | A FileReaderCallback object which is implemented by user to load a PDF document. It should not be null. If the input callback object is an AsyncReaderCallback object, and is_async is true that means the PDF document will be loaded by asynchronous method; otherwise, the document will be loaded in common way.
  [in] | is_async | Whether the input FileReaderCallback object is for asynchronously loading or not. Default value: false.

## ◆ constructor() [4/4]

PDFDoc.constructor | ( | path |  | ) |

Constructor, from an existing PDF file path.

After constructing such a PDF document object, please ensure the document object has been loaded before using most functions in class PDFDoc.

Parameters

  [in] | path | A full path of an existing PDF file. It should not be an empty string.

## ◆ CreateDSS()

PDFDoc.CreateDSS | ( |  | ) |

Create DSS information in current PDF document.

If current PDF document already has DSS information, this function will do nothing and return directly.

Returns
  None.

## ◆ CreateRootBookmark()

PDFDoc.CreateRootBookmark | ( |  | ) |

Create new bookmark root node.

If current PDF document already has the bookmark root node, this function will remove the old bookmark tree and create a new root node instead.

Returns
  A bookmark object that represents the root bookmark.

## ◆ DeleteIndirectObject()

PDFDoc.DeleteIndirectObject | ( | object_number |  | ) |

Delete an indirect object by indirect object number.

Parameters

  [in] | object_number | The indirect object number. It should be above 0.

Returns
  None.

## ◆ DoJSOpenAction()

PDFDoc.DoJSOpenAction | ( |  | ) |

Perform JavaScript actions when the document is opened.

Returns
  true means success, while false means failure.

## ◆ ExportAnnotToFDF()

<boolean> PDFDoc.ExportAnnotToFDF | ( | pdf_annot | ,
|  | fdf_doc |
| ) |  |

Export specified annotation to a FDF/XFDF document.

Parameters

  [in] | pdf_annot | A valid PDF annotation object to be exported to the FDF/XFDF document.
  [in] | fdf_doc | A valid FDF/XFDF document object, to which the specified annotation will be exported.

Returns
  true means success, while false means failure.

## ◆ ExportFormFieldsToFDF()

PDFDoc.ExportFormFieldsToFDF | ( | field_array | ,
|  | is_include | ,
|  | fdf_doc |
| ) |  |

Export specified form fields to a FDF/XFDF document.

Parameters

  [in] | field_array | An array of form fields. Parameter is_include will decide whether data of these form fields are to exported or not.
  [in] | is_include | A boolean value used to decide whether data of specified form fields are to be exported or not: true means data of specified form fields are to be exported, while false means data of specified form fields are not to be exported.
  [in] | fdf_doc | A valid FDF/XFDF document object, to which the specified form fields will be exported.

Returns
  true means success, while false means failure.

## ◆ ExportToFDF()

<boolean> PDFDoc.ExportToFDF | ( | fdf_doc | ,
|  | types | ,
|  | page_range |
| ) |  |

Export form fields and annotations to a FDF/XFDF document.

For more details about the type of PDF object available for exporting, please refer to Page 22 of "XML Forms Data Format Specification".

Parameters

  [in] | fdf_doc | A valid FDF/XFDF document object, to which form fields and annotations will be exported.
  [in] | types | Used to decide which kind of data will be exported. Please refer to values starting from PDFDoc.e_Forms and this can be one or a combination of these values. Default value: (PDFDoc.e_Forms | PDFDoc.e_Annots).
  [in] | page_range | A range object that specifies some pages. Data (in specified types) in these pages will be exported to FDF/XFDF document. If this range object is constructed by default constructor and not set any value, that means all the data (in specified types) of current document will be exported to FDF/XFDF document. This parameter is only useful when parameter types contains PDFDoc.e_Annots. Default value: a range object by default constructor and not set any value.

Returns
  true means success, while false means failure.

## ◆ GetBookmarkLevelDepth()

PDFDoc.GetBookmarkLevelDepth | ( |  | ) |

Get bookmark level depth.

Returns
  The depth of bookmark level. If current document does not have any bookmark, zero will be returned.

## ◆ GetCatalog()

PDFDoc.GetCatalog | ( |  | ) |

Get the catalog dictionary.

Returns
  The catalog dictionary. If there is no catalog dictionary or any error occurs, this function will return null.

## ◆ GetCertificateEncryptData()

PDFDoc.GetCertificateEncryptData | ( |  | ) |

Get encrypt data of certificate encryption.

This function is useful when current document is encrypted by certificate.

Returns
  The encrypt data of certificate encryption.

## ◆ GetCustomEncryptData()

PDFDoc.GetCustomEncryptData | ( |  | ) |

Get encrypt data of custom encryption.

This function is useful when current document is encrypted by custom.

Returns
  The encrypt data of custom encryption.

## ◆ GetDisplayMode()

<PDFPage> PDFDoc.GetDisplayMode | ( |  | ) |

Get the display mode.

Display mode specifies how the document should be displayed when opened.

Returns
  Display mode value. Please refer to values starting from PDFDoc.e_DisplayUseNone and this would be one of these values.

## ◆ GetDRMEncryptData()

PDFDoc.GetDRMEncryptData | ( |  | ) |

Get encrypt data of Foxit DRM encryption.

This function is useful when current document is encrypted by Foxit DRM.

Returns
  The encrypt data of Foxit DRM encryption.

## ◆ GetEditableHeaderFooter()

PDFDoc.GetEditableHeaderFooter | ( |  | ) |

Get the editable header footer object.

A PDF document may have been added header-footer sereral times, but only one of these header-footer can be editable. This function is to retreive the editable header-footer.

Returns
  A header-footer object that represents the editable header-footer.

## ◆ GetEmbeddedFontData()

<PageBasicInfo> PDFDoc.GetEmbeddedFontData | ( |  | ) |

Get embedded font data.

Returns
  The embedded font data.

## ◆ GetEncryptDict()

PDFDoc.GetEncryptDict | ( |  | ) |

Get the encrypt dictionary.

Returns
  The encrypt dictionary. If there is no encrypt dictionary or any error occurs, this function will return null.

## ◆ GetEncryptionType()

PDFDoc.GetEncryptionType | ( |  | ) |

Get the encryption type.

Returns
  Encryption type. Please refer to values starting from PDFDoc.e_EncryptNone and this would be one of these values.

## ◆ GetFileSize()

PDFDoc.GetFileSize | ( |  | ) |

Get file size.

Returns
  File size.

## ◆ GetFileVersion()

PDFDoc.GetFileVersion | ( |  | ) |

Get PDF file version stored in PDF header section.

Returns
  The file version. For example value 14 means version "1.4", value 15 means "1.5", and etc.

## ◆ GetFirstAvailPageIndex()

PDFDoc.GetFirstAvailPageIndex | ( |  | ) |

Get the page index of the fist available page.

This is useful for a linearized PDF document because in a linearized PDF document the first available page may not be the first page.
This function can be used only when document is loaded successfully.

Returns
  Page index of the first available page.

## ◆ GetFont()

PDFDoc.GetFont | ( | index |  | ) |

Get a font by index.

Parameters

  [in] | index | The index of PDF font. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetFontCount.

Returns
  A font object.

## ◆ GetFontCount()

PDFDoc.GetFontCount | ( |  | ) |

Count all the PDF fonts used in current PDF document.

This function will enumerate all the font resources used for pages, annotations, and interactive form.

Returns
  The count of fonts.

## ◆ GetHeader()

PDFDoc.GetHeader | ( |  | ) |

Get PDF header identifying the version of the PDF specification to which the file conforms.

Returns
  The PDF header string. It would be like "PDF-1.4", "PDF-1.5" and etc.

## ◆ GetIndirectObject()

PDFDoc.GetIndirectObject | ( | object_number |  | ) |

Get an indirect object by indirect object number.

Parameters

  [in] | object_number | The indirect object number. It should be above 0.

Returns
  A PDFObject object that receives the indirect PDF object. null means not found.

## ◆ GetInfo()

PDFDoc.GetInfo | ( |  | ) |

Get the information dictionary.

Document's information dictionary contains metadata for the document.

Returns
  The information dictionary. If there is no "Info" entry or any error occurs, this function will return null.

## ◆ GetOpenAction()

PDFDoc.GetOpenAction | ( |  | ) |

Get the action to be performed when the document is opened.

Returns
  An Action object.

## ◆ GetPage()

PDFDoc.GetPage | ( | index |  | ) |

Get a PDF page by index.

If current PDF document object is constructed with an AsyncReaderCallback which means to do asynchronous loading, this function may throw exception e_ErrDataNotReady. In this case, user should prepare data for specified range informed by callback function AsyncReaderCallback.AddDownloadHint and then call this function again.

Parameters

  [in] | index | The page index. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetPageCount.

Returns
  A PDF page object.

## ◆ GetPageBasicInfo()

PDFDoc.GetPageBasicInfo | ( | index |  | ) |

Get the basic information of a page specified by index.

This function can quickly get the basic information of a PDF page without getting that PDF page object. If current PDF document object is constructed with an AsyncReaderCallback which means to do asynchronous loading, this function may throw exception e_ErrDataNotReady. In this case, user should prepare data for specified range informed by callback function AsyncReaderCallback.AddDownloadHint and then call this function again.

Parameters

  [in] | index | The page index. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetPageCount.

Returns
  A page basic information object which contains the basic information of specified page.

## ◆ GetPageBasicInfoAsync()

PDFDoc.GetPageBasicInfoAsync | ( | index |  | ) |

Asynchronously get the basic information of a page specified by its index..

This function can quickly get the basic information of a PDF page without getting that PDF page object. If current PDF document object is constructed with an AsyncReaderCallback which means to do asynchronous loading, this function may throw exception e_ErrDataNotReady. In this case, user should prepare data for specified range informed by callback function AsyncReaderCallback.AddDownloadHint and then call this function again.

Parameters

  [in] | index | The page index. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetPageCount.

Returns
  A page basic information object which contains the basic information of specified page.

## ◆ GetPageCount()

PDFDoc.GetPageCount | ( |  | ) |

Get the count of pages.

Returns
  The count of pages.

## ◆ GetPagesDict()

PDFDoc.GetPagesDict | ( |  | ) |

Get the dictionary of "Pages".

Returns
  The dictionary of "Pages". If there is no "Pages" entry or any error occurs, this function will return null.

## ◆ GetPageText()

PDFDoc.GetPageText | ( | page_index |  | ) |

Get the specified PDF page text which the text is in display order.

Parameters

  [in] | page_index | The page index. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetPageCount.

Returns
  All the text content of the related PDF page which the text is in display order.

## ◆ GetPasswordType()

PDFDoc.GetPasswordType | ( |  | ) |

Get the type of current used password.

This function is useful after loading a PDF document, in order to get the type of the password which was used in the loading process.
If current document is a new one (not loading from existed PDF file), this function will return PDFDoc.e_PwdNoPassword.
If current document is constructed from an existing file but has not been loaded yet, this function will return PDFDoc.e_PwdInvalid.

Returns
  Password type. Please refer to values starting from PDFDoc.e_PwdInvalid and this would be one of these values.

## ◆ GetPayLoadData()

PDFDoc.GetPayLoadData | ( |  | ) |

Get payload data if current document's wrapper type is PDFDoc.e_WrapperPDFV2.

Returns
  The payload data. If no wrapper data can be found or current document's wrapper type is not PDFDoc.e_WrapperPDFV2, a payload data object with value 0 and empty strings will be returned.

## ◆ GetReadingBookmark()

PDFDoc.GetReadingBookmark | ( | index |  | ) |

Get a reading bookmark by index.

Parameters

  [in] | index | The index of reading bookmarks. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetReadingBookmarkCount.

Returns
  The reading bookmark object with specified index.

## ◆ GetReadingBookmarkCount()

PDFDoc.GetReadingBookmarkCount | ( |  | ) |

Get the count of reading bookmarks.

Returns
  The count of reading bookmarks.

## ◆ GetRMSEncryptData()

PDFDoc.GetRMSEncryptData | ( |  | ) |

Get encrypt data of RMS encryption.

This function is useful when current document is encrypted by RMS.

Returns
  The encrypt data of RMS encryption.

Note
  If module "RMS" is not defined in the license information which is used in function Library.Initialize, that means user has no right in using RMS related functions and this function will throw exception e_ErrNoRMSModuleRight.

## ◆ GetRootBookmark()

PDFDoc.GetRootBookmark | ( |  | ) |

Get bookmark root node.

Returns
  A bookmark object that represents the root bookmark. If there is no bookmark in current PDF document, this function will return a bookmark object which's function Bookmark.IsEmpty returns true.

## ◆ GetSecurityHandler()

PDFDoc.GetSecurityHandler | ( |  | ) |

Get current PDF security handler of current document.

Returns
  The PDF security handler object.

Note
  If module "RMS" is not defined in the license information which is used in function Library.Initialize, that means user has no right in using RMS related functions and this function will throw exception e_ErrNoRMSModuleRight.

## ◆ GetSignature()

PDFDoc.GetSignature | ( | index |  | ) |

Get a signature by index.

Parameters

  [in] | index | The index of signature. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetSignatureCount.

Returns
  The signature object.

## ◆ GetSignatureCount()

PDFDoc.GetSignatureCount | ( |  | ) |

Get the count of signature.

Returns
  The count of signature.

## ◆ GetStdEncryptData()

PDFDoc.GetStdEncryptData | ( |  | ) |

Get encrypt data of standard encryption (known as password encryption).

This function is useful when current document is encrypted by password.

Returns
  The encrypt data of standard encryption.

## ◆ GetTrailer()

PDFDoc.GetTrailer | ( |  | ) |

Get the trailer dictionary.

Returns
  The trailer dictionary. If there is no trailer dictionary or any error occurs, this function will return null.

## ◆ GetUserPassword()

PDFDoc.GetUserPassword | ( | owner_password |  | ) |

Get the user password based on owner password.

This function is useful when current document is encrypted by password.

Parameters

  [in] | owner_password | Owner password string.

Returns
  The user password string.

## ◆ GetUserPermissions()

PDFDoc.GetUserPermissions | ( |  | ) |

Get user access permissions.

Returns
  User access permission. Please refer to values starting from PDFDoc.e_PermPrint and this would be one of these values.

## ◆ GetWrapperData()

PDFDoc.GetWrapperData | ( |  | ) |

Get wrapper data if current document's wrapper type is PDFDoc.e_WrapperFoxit.

Returns
  The wrapper data. If no wrapper data can be found or current document's wrapper type is not PDFDoc.e_WrapperFoxit, a wrapper data object with value 0 and empty strings will be returned.

## ◆ GetWrapperOffset()

PDFDoc.GetWrapperOffset | ( |  | ) |

Get wrapper offset if current document's wrapper type is PDFDoc.e_WrapperFoxit.

Returns
  The wrapper offset. If no wrapper data can be found or current document's wrapper type is not PDFDoc.e_WrapperFoxit, -1 will be returned.

## ◆ GetWrapperType()

PDFDoc.GetWrapperType | ( |  | ) |

Get Wrapper type.

Returns
  The wrapper type. Please refer to values starting from PDFDoc.e_WrapperNone and this would be one or combination of its values.

## ◆ HasForm()

PDFDoc.HasForm | ( |  | ) |

Check whether current PDF document has interactive form (also known as AcroForm).

If current PDF document object is constructed with an AsyncReaderCallback which means to do asynchronous loading, this function may throw exception e_ErrDataNotReady. In this case, user should prepare data for specified range informed by callback function AsyncReaderCallback.AddDownloadHint and then call this function again.

Returns
  true means current document has interactive form. false means current document does not have interactive form.

## ◆ HasHeaderFooter()

PDFDoc.HasHeaderFooter | ( |  | ) |

Check whether current document has header-footer.

Returns
  true means current document has header-footer, while false means current document does not have header-footer.

## ◆ HasLayer()

PDFDoc.HasLayer | ( |  | ) |

Check whether current PDF document has layer (known as "Optional content group" in <PDF reference 1.7>) or not.

Returns
  true means current document has layer. false means current document does not have layer.

## ◆ HidePageTemplate()

PDFDoc.HidePageTemplate | ( | template_name |  | ) |

Hide a named page.

Pages in a PDF document can be mapped to names defined in the pages name tree in the PDF document. This function can be used to hide these named pages.
Class PDFNameTree (initialized with type PDFNameTree.e_Pages) can be used to determine which page names are available and to map pages to names.
After a PDF page has been hidden, the name will be moved to the document's templates name tree internally.

Parameters

  [in] | template_name | The name of a PDF page to be hidden.

Returns
  true means success, while false means failure.

## ◆ ImportFromFDF()

PDFDoc.ImportFromFDF | ( | fdf_doc | ,
|  | types | ,
|  | page_range |
| ) |  |

Import form fields and annotations from a FDF/XFDF document.

It also supports to import form fields in FDF template. The page associated with the FDF template will be inserted into the end of document. For more details about the type of PDF object available for exporting, please refer to Page 22 of "XML Forms Data Format Specification".

Parameters

  [in] | fdf_doc | A valid FDF/XFDF document object, from which form fields and annotations will be imported.
  [in] | types | Used to decide which kind of data will be imported. Please refer to values starting from PDFDoc.e_Forms and this can be one or a combination of these values. Default value: (PDFDoc.e_Forms | PDFDoc.e_Annots). It does not work if fdf_doc is the fdf template.
  [in] | page_range | A range object that specifies some pages. Data (in specified types) from FDF/XFDF document will be imported to these specified pages. If this range object is constructed by default constructor and not set any value, that means data (in specified types) from FDF/XFDF document will be imported to related PDF pages whose index have been defined in FDF/XFDF document. This parameter is only useful when parameter types contains PDFDoc.e_Annots. Default value: a range object by default constructor and not set any value. It does not work if fdf_doc is the fdf template.

Returns
  true means success, while false means failure.

## ◆ InsertDocument()

PDFDoc.InsertDocument | ( | dest_index | ,
|  | src_doc | ,
|  | options |
| ) |  |

Insert another PDF document to the specified location of current PDF document.

Parameters

  [in] | dest_index | A page index in current PDF document. This is used to specify where to insert the pages from src_doc: If parameter dest_index is less than 0, these pages will be inserted to the first. If parameter dest_index is equal to or larger than current page count, these pages will be inserted to the end.
  [in] | src_doc | A PDF document object which represents the PDF document to be inserted to current PDF document. All the pages in this document will be inserted to current PDF document. Please keep this source PDF document object valid until current document will not be saved any more or is closed.
  [in] | options | Options for inserting a PDF document. Please refer to values starting from PDFDoc.e_InsertDocOptionAttachments and this can be one or a combination of these values. 0 means no option is used.

Returns
  None.

## ◆ InsertPage() [1/2]

PDFDoc.InsertPage | ( | index | ,
|  | size |
| ) |  |

Insert a new blank PDF page to document, by index.

Parameters

  [in] | index | The page index for new page. If parameter index is less than 0, the new page will be inserted to the first. If parameter index is equal to or larger than current page count, the new page will be inserted to the end.
  [in] | size | Size type of new page. Please refer to values starting from PDFPage.e_SizeLetter and this should be one of these values. Default value: PDFPage.e_SizeLetter.

Returns
  A new PDF page object, which represents a blank page.

## ◆ InsertPage() [2/2]

PDFDoc.InsertPage | ( | index | ,
|  | width | ,
|  | height |
| ) |  |

Insert a new blank PDF page to document, by index.

Parameters

  [in] | index | The page index for new page. If parameter index is less than 0, the new page will be inserted to the first. If parameter index is equal to or larger than current page count, the new page will be inserted to the end.
  [in] | width | Width of new page (unit is 1/72 inch).
  [in] | height | Height of new page (unit is 1/72 inch).

Returns
  A new PDF page object which represents a blank page.

## ◆ InsertReadingBookmark()

PDFDoc.InsertReadingBookmark | ( | reading_bookmark_index | ,
|  | title | ,
|  | dest_page_index |
| ) |  |

Insert a reading bookmark to current PDF document.

Parameters

  [in] | reading_bookmark_index | A reading bookmark index. If reading_bookmark_index is less than 0, the new reading bookmark will be inserted to the first. If reading_bookmark_index is equal to or larger than the count of reading bookmarks, the new reading bookmark will be inserted to the end.
  [in] | title | Title string for new reading bookmark and should not an empty string.
  [in] | dest_page_index | The index of destination page.

Returns
  A new reading bookmark object.

## ◆ IsEmpty()

PDFDoc.IsEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ IsEncrypted()

PDFDoc.IsEncrypted | ( |  | ) |

Check whether current document is an encrypted file or not.

Returns
  true means current document is an encrypted file, while false means current document is not an encrypted file.

## ◆ IsLinearized()

PDFDoc.IsLinearized | ( |  | ) |

Check if current PDF document is a linearized file.

- If current document object is constructed with an AsyncReaderCallback object, this function can be used before or after the document is loaded successfully. Specially, if this function is called before document is loaded successfully, application should ensure the first 1024 bytes of the PDF file is available; otherwise, this function will call the callback function AsyncReaderCallback.AddDownloadHint to notify application the range of data which should be downloaded by application then, and then this function will throw exception e_ErrDataNotReady.
- If current document object is constructed from other methods or with a common FileReaderCallback object, this function can only be used after the document is loaded successfully; otherwise, exception e_ErrUnknownState will be thrown.

Returns
  true means current PDF document is a linearized file, and false means current PDF document is not a linearized file.

## ◆ IsOwnerPassword()

PDFDoc.IsOwnerPassword | ( | password |  | ) |

Check if input password is the owner password of current PDF document.

Parameters

  [in] | password | A password string to be detected.

Returns
  true means input password is the owner password of current PDF document, while false means input password is not the owner password of current PDF document.

## ◆ IsPortfolio()

PDFDoc.IsPortfolio | ( |  | ) |

Check whether current PDF document is a portfolio file or not.

Returns
  true means current PDF document is a portfolio file, while false means not.

## ◆ IsTaggedPDF()

PDFDoc.IsTaggedPDF | ( |  | ) |

Check if current PDF document is a Tagged PDF file.

Returns
  true means current PDF document is a Tagged PDF file, and false means current PDF document is not a Tagged PDF file.

## ◆ IsUserPassword()

PDFDoc.IsUserPassword | ( | password |  | ) |

Check if input password is the user password of current PDF document.

Parameters

  [in] | password | A password string to be detected.

Returns
  true means input password is the user password of current PDF document, while false means input password is not the user password of current PDF document.

## ◆ IsWrapper()

PDFDoc.IsWrapper | ( |  | ) |

Check whether current document is a wrapper file or not.

Returns
  true means current document is a wrapper file, while false means current document is not a wrapper file.

## ◆ IsXFA()

PDFDoc.IsXFA | ( |  | ) |

Check whether current PDF document is an XFA document.

Currently, Foxit PDF SDK does not fully support XFA document. When loading an XFA document, Foxit PDF SDK may only load the XFA wrapper level, and cannot have access to the real XFA content. Foxit PDF SDK does not support to insert/import/remove/move pages in an XFA document yet.

Returns
  true means current document is an XFA document, while false means current document is not an XFA document.

## ◆ Load()

PDFDoc.Load | ( | password |  | ) |

Load current document content by using a specified password.

If current PDF document object is constructed with an AsyncReaderCallback which means to do asynchronous loading, this function may return e_ErrDataNotReady. In this case, user should prepare data for specified range informed by callback function AsyncReaderCallback.AddDownloadHint and then call this function again.

Parameters

  [in] | password | The password string, used to load current document content. The password can be either user password or owner password. If current document is not encrypted by password, just pass an empty string. Default value: an empty string.

Returns
  e_ErrSuccess means success.
  e_ErrFile means there is any error occurs when accessing current document.
  e_ErrPassword means input password is wrong.
  e_ErrFormat means the format of current document content is not PDF or the file has been corrupted.
  e_ErrSecurityHandler means current PDF document is encrypted by some unsupported security handler.
  e_ErrCertificate means current PDF document is encrypted by digital certificate and current user does not have the correct certificate.
  For other error code value, please refer to values starting from e_ErrSuccess for more details.

## ◆ LoadW()

PDFDoc.LoadW | ( | password |  | ) |

Load current document content by using a specified password.

If current PDF document object is constructed with an AsyncReaderCallback which means to do asynchronous loading, this function may return e_ErrDataNotReady. In this case, user should prepare data for specified range informed by callback function AsyncReaderCallback.AddDownloadHint and then call this function again.

Parameters

  [in] | password | The password string, used to load current document content. The password can be either user password or owner password. If current document is not encrypted by password, just pass an empty string. Default value: an empty string.

Returns
  e_ErrSuccess means success.
  e_ErrFile means there is any error occurs when accessing current document.
  e_ErrPassword means input password is wrong.
  e_ErrFormat means the format of current document content is not PDF or the file has been corrupted.
  e_ErrSecurityHandler means current PDF document is encrypted by some unsupported security handler.
  e_ErrCertificate means current PDF document is encrypted by digital certificate and current user does not have the correct certificate.
  For other error code value, please refer to values starting from e_ErrSuccess for more details.

## ◆ MovePagesTo()

PDFDoc.MovePagesTo | ( | page_range | ,
|  | dest_index |
| ) |  |

Move one or more pages (specified by index) to a new index position.

If move only one page, this function just has the same feature as function PDFDoc.MovePageTo.
If move more than one page, these page will keep the order defined in parameter page_range and be moved to the destination index position as a whole.
After this function is successful, indexes of moved pages will be changed and indexes of the rest pages may be affected as well.

Parameters

  [in] | page_range | A range object which should at least contain one valid range. All the related pages will keep the order (specified by this range) and be moved as a whole. If there exist duplicated indexes in the range, only the last occurrence will be useful.
  [in] | dest_index | Index of the destination position, based on current page array. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetPageCount.

Returns
  true means success or no need to move current page, while false means failure.

## ◆ MovePageTo()

PDFDoc.MovePageTo | ( | page | ,
|  | dest_index |
| ) |  |

Move a specified page to a new index position.

If the specified page is successfully moved to the new index position, page index of all the pages between the new index and old index of the specified page will be changed as well.

Parameters

  [in] | page | A PDF page to be moved. It should be in current PDF document.
  [in] | dest_index | Index of the destination position in page array. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetPageCount. If parameter dest_index is just the same as the page index of parameter page, no change will be done and this function will return true directly.

Returns
  true means success or no need to move current page, while false means failure.

## ◆ RemoveAllHeaderFooters()

PDFDoc.RemoveAllHeaderFooters | ( |  | ) |

Remove all header-footers.

Returns
  true means success, while false means failure.

## ◆ RemoveBookmark()

PDFDoc.RemoveBookmark | ( | bookmark |  | ) |

Remove a specified bookmark.

Parameters

  [in] | bookmark | The valid bookmark that would be deleted.

Returns
  true means success, while false means failure.

## ◆ RemoveOpenAction()

PDFDoc.RemoveOpenAction | ( |  | ) |

Remove the action to be performed when the document is opened.

Returns
  true means success, while false means failure.

## ◆ RemovePage() [1/2]

PDFDoc.RemovePage | ( | index |  | ) |

Remove a PDF page by page index.

Parameters

  [in] | index | The page index. Valid range: from 0 to (count-1). count is returned by function PDFDoc.GetPageCount.

Returns
  true means success, while false means failure.

## ◆ RemovePage() [2/2]

PDFDoc.RemovePage | ( | page |  | ) |

Remove a specified PDF page.

Once the specified PDF page is removed successfully, the page object cannot be used any more.

Parameters

  [in] | page | A PDF page object that represents the PDF page to be removed. The page should be in current PDF document.

Returns
  true means success, while false means failure.

## ◆ RemoveReadingBookmark()

PDFDoc.RemoveReadingBookmark | ( | reading_bookmark |  | ) |

Remove a reading bookmark from current PDF document.

Parameters

  [in] | reading_bookmark | A valid reading bookmark to be removed.

Returns
  true means success, while false means failure.

## ◆ RemoveSecurity()

PDFDoc.RemoveSecurity | ( |  | ) |

Remove the security handler from current document, so that the later saved document will be unencrypted.

Returns
  true means success, while false means failure.

Note
  If module "RMS" is not defined in the license information which is used in function Library.Initialize, that means user has no right in using RMS related functions and this function will throw exception e_ErrNoRMSModuleRight.

## ◆ RemoveSignature()

PDFDoc.RemoveSignature | ( | signature |  | ) |

Remove a signature.

Parameters

  [in] | signature | A valid signature to be removed. If this signature's type is Signature.e_SignatureTypePagingSeal, this function will remove all signatures related to this signature.

Returns
  None.

## ◆ SaveAs()

PDFDoc.SaveAs | ( | file_path | ,
|  | save_flags |
| ) |  |

Save current PDF document as another PDF file.

If current document is loaded from an existing PDF file and a different file version has been set by PDFDoc.SetFileVersion before saving, Foxit PDF SDK will ignore PDFDoc.e_SaveFlagIncremental in parameter save_flags and use the file version in saved PDF file.

Parameters

  [in] | file_path | A full path for the new saved PDF file. It should not be an empty string.
  [in] | save_flags | Document saving flags. Please refer to values starting from PDFDoc.e_SaveFlagNormal and this can be one or combination of these values. Default value: PDFDoc.e_SaveFlagNormal.

Returns
  true means the saving is successfully finished, while false means failure.

Note
  This function does not support to save current PDF document object just back to the PDF file which is used to construct current PDF object. In order to do so, user is recommended to do as following steps:
  Assume that current PDF object is constructed from a PDF file named "org.pdf".
  1. Use current function to save current PDF object to an temporary file. Here, this temporary file is named as "temp.tmp".
  2. Ensure that current PDF object has destructed – which is equal to "close document".
  3. Remove "org.pdf" and rename "temp.tmp" to "org.pdf".
  Then user can open the saved PDF file to do other operation.

## ◆ SaveAsWrapperFile()

PDFDoc.SaveAsWrapperFile | ( | file_path | ,
|  | wrapper_data | ,
|  | user_permissions | ,
|  | owner_password |
| ) |  |

Save current PDF document as a wrapper file.

PDF wrapper is an extended standard, and it helps to hint some information to viewers.
PDF wrapper consists of

- wrapper type: it is an identity string,
- wrapper offset: it tells the end of original data,
- wrapper template: it is the content of wrapper document.

This function uses the current size of file which is specified by file_path to set wrapper offset.

Parameters

  [in] | file_path | A full path of a PDF file. Current PDF document will be saved into this PDF file as a wrapper file.
  [in] | wrapper_data | Wrapper data. If this is null, no wrapper data is used. Default value: null.
  [in] | user_permissions | User permissions for the wrapper document. Pass 0xFFFFFFFC if no special permissions is needed. Please refer to values starting from PDFDoc.e_PermPrint and this should be one or combination of these values. Default value: 0xFFFFFFFC.
  [in] | owner_password | Owner password. If this is an empty string, parameter user_permissions will be ignored. Default value: an empty string.

Returns
  true means success, while false means failure.

## ◆ SetCacheFile()

PDFDoc.SetCacheFile | ( | file_stream | ,
|  | is_own_file_stream |
| ) |  |

Set cache file (represented by a file stream) to current PDF document.

Cache file can be used to cache the large amount of data which are generated when the content stream is generated.

Parameters

  [in] | file_stream | A StreamCallback object which is implemented by user to cache data. It can be null. The origin cache file will be released if it is null.
  [in] | is_own_file_stream | Used to decide whether Foxit PDF SDK should own input stream callback object or not: true means input stream callback object will be destroyed by Foxit PDF SDK (by calling callback function StreamCallback.Release) when no need to cache data anymore for current PDF document. false means user should be responsible to destroy the stream callback object when no need to modify any content of current PDF document.

Returns
  None.

## ◆ SetDisplayMode()

PDFDoc.SetDisplayMode | ( | display_mode |  | ) |

Set the display mode.

Display mode specifies how the document should be displayed when opened.

Parameters

  [in] | display_mode | Display mode value. Please refer to values starting from PDFDoc.e_DisplayUseNone and this should be one of these values.

Returns
  None.

## ◆ SetFileVersion()

PDFDoc.SetFileVersion | ( | version |  | ) |

Set the PDF file version which will be stored in PDF header section of the saved PDF file.

The new file version will not affect on current document directly, but will be used in the saved PDF file in function PDFDoc.SaveAs or PDFDoc.StartSaveAs. This function does not check whether the PDF content matches the specified version.
If user wants to do compliance conversion about PDF version, please refer to module "Compliance" and use class PDFCompliance.

Parameters

  [in] | version | An integer that specifies the file version, for example value 14 means version "1.4", value 15 means "1.5", and etc. This value should be from 10 to 17 or 20 and be equal or greater than current version of current PDF file.

Returns
  None.

## ◆ SetOpenAction()

PDFDoc.SetOpenAction | ( | action |  | ) |

Set the action to be performed when the document is opened.

Parameters

  [in] | action | A valid action to be set. Currently only support following types as the new action: Action.e_TypeGoto, Action.e_TypeURI, Action.e_TypeJavaScript, Action.e_TypeNamed, Action.e_TypeSubmitForm, Action.e_TypeResetForm, Action.e_TypeHide, Action.e_TypeImportData.

Returns
  true means success, while false means failure.

## ◆ SetSecurityHandler()

PDFDoc.SetSecurityHandler | ( | handler |  | ) |

Set a PDF security handler for encryption, such as standard encryption(password), certificate encryption, and so on.

Parameters

  [in] | handler | A PDF security handler object.

Returns
  true means success, while false means failure.

Note
  If module "RMS" is not defined in the license information which is used in function Library.Initialize, that means user has no right in using RMS related functions and this function will throw exception e_ErrNoRMSModuleRight.

## ◆ StartAddTiledWatermark() [1/4]

PDFDoc.StartAddTiledWatermark | ( | page | ,
|  | settings | ,
|  | page_range | ,
|  | pause |
| ) |  |

Add page type tiled watermark to PDF pages.

If the watermark is tiled to multiple pages, these pages will keep the order defined in the parameter page_range. If the parameter page_range is initialized to empty, the watermark will be tiled to all pages of the document by default. In addition, XFA dynamic documents don't support inserting tiled watermarks.

Parameters

  [in] | page | A valid PDF page object, whose content will be used as the content of the tiled watermark.
  [in] | settings | Tiled watermark settings, containing layout setting.
  [in] | page_range | A range object that specifies some pages. These pages will be added tiled watermarks. The valid page range: from 0 to (count -1). count is returned by function PDFDoc.GetPageCount. If this range object is constructed by default constructor and not set any value, that means all the pages of current document will be added tiled watermarks.
  [in] | pause | Pause callback object which decides if the recognizing process needs to be paused. This can be null which means not to pause during the recognizing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartAddTiledWatermark() [2/4]

PDFDoc.StartAddTiledWatermark | ( | src_img_file_path | ,
|  | settings | ,
|  | page_range | ,
|  | pause |
| ) |  |

Add image type tiled watermark to PDF pages by image path.

If the watermark is tiled to multiple pages, these pages will keep the order defined in the parameter page_range. If the parameter page_range is initialized to empty, the watermark will be tiled to all pages of the document by default. In addition, XFA dynamic documents don't support inserting tiled watermarks.
Image tiled watermarks support .bmp .dib .jpg .jpeg .jpe .gif .png .tif .tiff format.

Parameters

  [in] | src_img_file_path | Path of a image file. This should not be an empty string.
  [in] | settings | Tiled watermark settings, containing layout setting.
  [in] | page_range | A range object that specifies some pages. These pages will be added tiled watermarks. The valid page range: from 0 to (count -1). count is returned by function PDFDoc.GetPageCount. If this range object is constructed by default constructor and not set any value, that means all the pages of current document will be added tiled watermarks.
  [in] | pause | Pause callback object which decides if the recognizing process needs to be paused. This can be null which means not to pause during the recognizing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartAddTiledWatermark() [3/4]

PDFDoc.StartAddTiledWatermark | ( | src_img_stream | ,
|  | settings | ,
|  | page_range | ,
|  | pause |
| ) |  |

Add image type tiled watermark to PDF pages by image stream.

If the watermark is tiled to multiple pages, these pages will keep the order defined in the parameter page_range. If the parameter page_range is initialized to empty, the watermark will be tiled to all pages of the document by default. In addition, XFA dynamic documents don't support inserting tiled watermark.
Image tiled watermarks support .bmp .dib .jpg .jpeg .jpe .gif .png .tif .tiff format.

Parameters

  [in] | src_img_stream | A FileReaderCallback object which is image stream by user to pass image data to Foxit PDF SDK. It must be vaild.
  [in] | settings | Tiled watermark settings, containing layout setting.
  [in] | page_range | A range object that specifies some pages. These pages will be added tiled watermarks. The valid page range: from 0 to (count -1). count is returned by function PDFDoc.GetPageCount. If this range object is constructed by default constructor and not set any value, that means all the pages of current document will be added tiled watermarks.
  [in] | pause | Pause callback object which decides if the recognizing process needs to be paused. This can be null which means not to pause during the recognizing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartAddTiledWatermark() [4/4]

PDFDoc.StartAddTiledWatermark | ( | text | ,
|  | settings | ,
|  | page_range | ,
|  | pause |
| ) |  |

Add text type tiled watermark to PDF pages.

If the watermark is tiled to multiple pages, these pages will keep the order defined in the parameter page_range. If the parameter page_range is initialized to empty, the watermark will be tiled to all pages of the document by default. In addition, XFA dynamic documents don't support inserting tiled watermarks.

Parameters

  [in] | text | A text string. This will be used as the content of the tiled watermark, It should not be an empty string.
  [in] | settings | Tiled watermark settings, containing layout setting.
  [in] | properties | Text properties for tiled watermark.
  [in] | page_range | A range object that specifies some pages. These pages will be added tiled watermarks. The valid page range: from 0 to (count -1). count is returned by function PDFDoc.GetPageCount. If this range object is constructed by default constructor and not set any value, that means all the pages of current document will be added tiled watermarks.
  [in] | pause | Pause callback object which decides if the recognizing process needs to be paused. This can be null which means not to pause during the recognizing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartEmbedAllFonts()

PDFDoc.StartEmbedAllFonts | ( | pause |  | ) |

Start to convert all un-embeded fonts to embeded fonts.

It may take a long time to convert all un-embedded fonts to embedded fonts in current PDF document, so this function uses a progressive process to do this.
This function only works with fonts available for embedding. Whether a font is embeddable or not can be checked by function Font.IsSupportEmbedded.
This function will delete the original font object after embedding the font, however, the reference to the original font in the document will still exist.

Parameters

  [in] | pause | Pause callback object which decides if the embedding process needs to be paused. This can be null which means not to pause during the embedding process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartExtractPages() [1/2]

<Progressive> PDFDoc.StartExtractPages | ( | file | ,
|  | options | ,
|  | page_range | ,
|  | pause |
| ) |  |

Start to extract pages from current PDF document.

It may take a long time to extracting pages, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | file | A FileWriterCallback object which is implemented by user to store the data of all the extracted pages in custom method.
  [in] | options | Options for extracting pages. Please refer to values starting from PDFDoc.e_ExtractPagesOptionAnnotation and this can be one or a combination of these values. 0 means no option is used.
  [in] | page_range | A range object to specify which pages are to be extracted. If this range object is constructed by default constructor and not set any value, all pages in the current document will be extracted. Default value: a range object by default constructor and not set any value.
  [in] | pause | Pause object which decides if the extracting process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartExtractPages() [2/2]

<Progressive> PDFDoc.StartExtractPages | ( | file_path | ,
|  | options | ,
|  | page_range | ,
|  | pause |
| ) |  |

Start to extract pages from current PDF document.

It may take a long time to extracting pages, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | file_path | A full path for the new saved PDF file which is used to save the extracted pages. It should not be an empty string.
  [in] | options | Options for extracting pages. Please refer to values starting from PDFDoc.e_ExtractPagesOptionAnnotation and this can be one or a combination of these values. 0 means no option is used.
  [in] | page_range | A range object to specify which pages are to be extracted. If this range object is constructed by default constructor and not set any value, all pages in the current document will be extracted. Default value: a range object by default constructor and not set any value.
  [in] | pause | Pause object which decides if the extracting process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartGetPayloadFile()

PDFDoc.StartGetPayloadFile | ( | payload_file | ,
|  | pause |
| ) |  |

Start to get payload file.

It may take a long time to getting payload document, so this function uses a progressive process to do this.

Parameters

  [in] | payload_file | A FileWriterCallback callback object. User should implement the callback function in this callback object in order that this callback object can be used to save payload file.
  [in] | pause | Pause callback object which decides if the parsing process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartImportPages()

<Progressive> PDFDoc.StartImportPages | ( | dest_index | ,
|  | src_doc | ,
|  | flags | ,
|  | layer_name | ,
|  | page_range | ,
|  | pause |
| ) |  |

Start to import pages from another PDF document (via PDF document object).

It may take a long time to importing pages, so Foxit PDF SDK uses a progressive process to do this.
Signed signatures in the pages of source PDF document will not be imported into current PDF document.
Currently, if either current PDF document or the source PDF document contains XFA, not support to do the importing.
If this function is used to combine two PDF files, pages are strongly recommended to be imported to the end of destination PDF file instead of to the beginning of destination PDF file.

Parameters

  [in] | dest_index | A page index in current PDF document. This is used to specify where the imported pages will be inserted: If parameter dest_index is less than 0, the imported pages will be inserted to the first. If parameter dest_index is equal to or larger than current page count, the imported pages will be inserted to the end.
  [in] | src_doc | A PDF document object which is the source PDF document. Pages in this document will be imported to current PDF document. Please keep this source PDF document object valid until current document will not be saved any more or is closed.
  [in] | flags | Options for importing pages. Please refer to values starting from PDFDoc.e_ImportFlagNormal and this can be one or a combination of these values. Default value: PDFDoc.e_ImportFlagNormal.
  [in] | layer_name | The name of non-selectable label or the prefix name of the non-selectable label to be shown in layer panel of application. Default value: an empty string. If parameter flags contains PDFDoc.e_ImportFlagWithLayers, this should not be empty and should be a valid string. If parameter flags does not contain PDFDoc.e_ImportFlagWithLayers, this string will be ignored. If all the pages of source PDF document is to be imported to current document, all layers from source document will be grouped under a non-selectable label, and this string will be directly used as the label. If only part of pages of source PDF document is to be imported to current document, layers in the same page will be grouped under a single non-selectable label, and this string will be used as the prefix name of the label. The label will be like "layerName_Page_X".
  [in] | page_range | A range object to specify which pages is to be inserted. If this range object is constructed by default constructor and not set any value, all pages in the source document will be imported. Default value: a range object by default constructor and not set any value.
  [in] | pause | Pause object which decides if the importing process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartImportPagesFromFilePath()

PDFDoc.StartImportPagesFromFilePath | ( | dest_index | ,
|  | src_file_path | ,
|  | password | ,
|  | flags | ,
|  | layer_name | ,
|  | page_range | ,
|  | pause |
| ) |  |

Start to import pages from another PDF document (via file path).

It may take a long time to importing pages, so Foxit PDF SDK uses a progressive process to do this.
Signed signatures in the pages of source PDF document will not be imported into current PDF document.
Currently, Foxit PDF SDK does not support to do the importing if either current PDF document or the source PDF document contains XFA.
If this function is used to combine two PDF files, pages are strongly recommended to be imported to the end of destination PDF file instead of to the beginning of destination PDF file.

Parameters

  [in] | dest_index | A page index in current PDF document. This is used to specify where the imported pages will be inserted. If parameter dest_index is less than 0, the imported pages will be inserted to the first. If parameter dest_index is equal to or larger than current page count, the imported pages will be inserted to the end.
  [in] | src_file_path | A full path of an existing PDF file as the source PDF document. Some pages will be imported from this PDF file to current PDF document.
  [in] | password | A password string used to load source PDF document content. The password can be either user password or owner password. If source PDF document is not encrypted by password, just pass an empty string.
  [in] | flags | Options for importing pages. Please refer to values starting from PDFDoc.e_ImportFlagNormal and this can be one or a combination of these values. Default value: PDFDoc.e_ImportFlagNormal.
  [in] | layer_name | The name of non-selectable label or the prefix name of the non-selectable label to be shown in layer panel of application. Default value: an empty string. If parameter flags contains PDFDoc.e_ImportFlagWithLayers, this should not be empty and should be a valid string. If parameter flags does not contain PDFDoc.e_ImportFlagWithLayers, this string will be ignored. If all the pages of source PDF document is to be imported to current document, all layers from source document will be grouped under a non-selectable label, and this string will be directly used as the label. If only part of pages of source PDF document is to be imported to current document, layers in the same page will be grouped under a single non-selectable label, and this string will be used as the prefix name of the label. The label will be like "layerName_Page_X".
  [in] | page_range | A range object to specify which pages is to be imported. If this range object is constructed by default constructor and not set any value, all pages in the source document will be imported. Default value: a range object by default constructor and not set any value.
  [in] | pause | Pause object which decides if the importing process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartLoad()

PDFDoc.StartLoad | ( | password | ,
|  | is_cache_stream | ,
|  | pause |
| ) |  |

Start to loading current document content by using a specified password.

It may take a long time to loading document content, so this function uses a progressive process to do this.
When using this function, parameter is_cache_stream can be used to decide whether to load stream content into memory or not:

- Loading stream content into memory will improve performance for frequent access, however, it will also consume a lot of memory space.
- Not to load stream content into memory, that means to leave stream content on file system, and read them when needed. This may reduce the performance a little bit, but greatly reduce the memory consumption, especially when the file is big.

Parameters

  [in] | password | A password string, used to load current document content. The password can be either user password or owner password. If current document is not encrypted by password, just pass an empty string. Default value: an empty string.
  [in] | is_cache_stream | true means to load stream content into memory, and false means not to load stream content into memory and just leave stream content on file system and read them when needed. Please refer to "Details" part about the difference between these two modes. Default value: true.
  [in] | pause | Pause object which decides if the loading process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartLoadW()

PDFDoc.StartLoadW | ( | password | ,
|  | is_cache_stream | ,
|  | pause |
| ) |  |

Start to loading current document content by using a specified password.

It may take a long time to loading document content, so this function uses a progressive process to do this.
When using this function, parameter is_cache_stream can be used to decide whether to load stream content into memory or not:

- Loading stream content into memory will improve performance for frequent access, however, it will also consume a lot of memory space.
- Not to load stream content into memory, that means to leave stream content on file system, and read them when needed. This may reduce the performance a little bit, but greatly reduce the memory consumption, especially when the file is big.

Parameters

  [in] | password | A password string, used to load current document content. The password can be either user password or owner password. If current document is not encrypted by password, just pass an empty string. Default value: an empty string.
  [in] | is_cache_stream | true means to load stream content into memory, and false means not to load stream content into memory and just leave stream content on file system and read them when needed. Please refer to "Details" part about the difference between these two modes. Default value: true.
  [in] | pause | Pause object which decides if the loading process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRecognizeForm()

PDFDoc.StartRecognizeForm | ( | pause |  | ) |

Start to recognize form in current PDF document.

It may take a long time to recognize form in PDF document, so this function uses a progressive process to do this.
For windows platform, users are strongly recommended to initialize OCR engine by calling function OCREngine.Initialize before calling this function.

Parameters

  [in] | pause | Pause callback object which decides if the recognizing process needs to be paused. This can be null which means not to pause during the recognizing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartSaveAs() [1/2]

<Progressive> PDFDoc.StartSaveAs | ( | file | ,
|  | save_flags | ,
|  | pause |
| ) |  |

Start to save current PDF document as another PDF file.

It may take a long time to saving PDF document, so this function uses a progressive process to do this.
If current document is loaded from an existing PDF file and a different file version has been set by PDFDoc.SetFileVersion before saving, Foxit PDF SDK will ignore PDFDoc.e_SaveFlagIncremental in parameter save_flags and use the file version in saved PDF file.

Parameters

  [in] | file | A FileWriterCallback object which is implemented by user to save a PDF document.
  [in] | save_flags | Document saving flags. Please refer to values starting from PDFDoc.e_SaveFlagNormal and this can be one or combination of these values. Default value: PDFDoc.e_SaveFlagNormal.
  [in] | pause | Pause callback object which decides if the parsing process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

Note
  This function does not support to save current PDF document object just back to the PDF file which is used to construct current PDF object. In order to do so, user is recommended to do as following steps:
  Assume that current PDF object is constructed from a PDF file named "org.pdf".
  1. Use current function to save current PDF object to an temporary file. Here, this temporary file is named as "temp.tmp".
  2. Ensure that current PDF object has destructed – which is equal to "close document".
  3. Remove "org.pdf" and rename "temp.tmp" to "org.pdf".
  Then user can open the saved PDF file to do other operation.

## ◆ StartSaveAs() [2/2]

PDFDoc.StartSaveAs | ( | file_path | ,
|  | save_flags | ,
|  | pause |
| ) |  |

Start to save current PDF document as another PDF file.

It may take a long time to saving PDF document, so this function uses a progressive process to do this.
If current document is loaded from an existing PDF file and a different file version has been set by PDFDoc.SetFileVersion before saving, Foxit PDF SDK will ignore PDFDoc.e_SaveFlagIncremental in parameter save_flags and use the file version in saved PDF file.

Parameters

  [in] | file_path | A full path for the new saved PDF file. It should not be an empty string.
  [in] | save_flags | Document saving flags. Please refer to values starting from PDFDoc.e_SaveFlagNormal and this can be one or combination of these values. Default value: PDFDoc.e_SaveFlagNormal.
  [in] | pause | Pause callback object which decides if the parsing process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

Note
  This function does not support to save current PDF document object just back to the PDF file which is used to construct current PDF object. In order to do so, user is recommended to do as following steps:
  Assume that current PDF object is constructed from a PDF file named "org.pdf".
  1. Use current function to save current PDF object to an temporary file. Here, this temporary file is named as "temp.tmp".
  2. Ensure that current PDF object has destructed – which is equal to "close document".
  3. Remove "org.pdf" and rename "temp.tmp" to "org.pdf".
  Then user can open the saved PDF file to do other operation.

## ◆ StartSaveAsPayloadFile()

PDFDoc.StartSaveAsPayloadFile | ( | file_path | ,
|  | payload_file_path | ,
|  | crypto_filter | ,
|  | description | ,
|  | version | ,
|  | ave_flags | ,
|  | pause |
| ) |  |

Start to save current PDF document as a wrapper document with a payload document (defined in PDF 2.0).

It may take a long time to saving PDF document, so this function uses a progressive process to do this.
If current document is loaded from an existing PDF file and a different file version has been set by PDFDoc.SetFileVersion before saving, Foxit PDF SDK will ignore PDFDoc.e_SaveFlagIncremental in parameter save_flags and use the file version in saved PDF file.

Parameters

  [in] | file_path | A full path for the new saved PDF file. It should not be an empty string.
  [in] | payload_file_path | A full path of a PDF document which will be used as payload document. It should not be an empty string.
  [in] | crypto_filter | The name of the cryptographic filter used to encrypt the encrypted payload document.
  [in] | description | Description for wrapper file to show applications or confront users prompt information.
  [in] | version | The version number of the cryptographic filter used to encrypt the encrypted payload referenced by this dictionary.
  [in] | save_flags | Document saving flags. Please refer to values starting from PDFDoc.e_SaveFlagNormal and this can be one or combination of these values. Default value: PDFDoc.e_SaveFlagNormal.
  [in] | pause | Pause callback object which decides if the parsing process needs to be paused. This can be null which means not to pause during the parsing process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ UpdateHeaderFooter()

PDFDoc.UpdateHeaderFooter | ( | headerfooter |  | ) |

Update header-footer.

A PDF document can be added header-footer sereral times. When a header-footer is updated to the document, the old ones which appear in the same place with the new one will all be removed and then the new one will be added.

Parameters

  [in] | headerfooter | A valid header-footer object to be updated to current document.

Returns
  None.

## Member Data Documentation

## ◆ e_DisplayUseNone

PDFDoc.e_DisplayUseNone
| static

Enumeration for display mode which specifies how the document should be displayed when opened.

Values of this enumeration should be used alone.

When document is opened, neither document outlines nor thumbnail images are visible.

## ◆ e_EncryptUnknown

PDFDoc.e_EncryptUnknown
| static

Enumeration for encryption type.

Values of this enumeration should be used alone.

Unknown encryption type.

## ◆ e_ExtractPagesOptionAnnotation

PDFDoc.e_ExtractPagesOptionAnnotation
| static

Enumeration for options used for extracting pages.

Values of this enumeration can be used alone or in combination.

If set, that means annotations related to extracted pages will be extracted as well.

## ◆ e_Forms

PDFDoc.e_Forms
| static

Enumeration for data type used to decide which object(s) will be imported from or exported to FDF/XFDF document.

Values of this enumeration can be used alone or in combination.

If set, form fields are to imported from or exported to FDF/XFDF document.

## ◆ e_ImportFlagNormal

PDFDoc.e_ImportFlagNormal
| static

Enumeration for flags used for importing pages.

Values of this enumeration can be used alone or in combination.

Import pages normally.

## ◆ e_ImportFlagShareStream

PDFDoc.e_ImportFlagShareStream
| static

Import pages without cloning stream objects into memory.

This flags is only useful when the source PDF document has not been encrypted. If this flag is used for importing pages, it will reduce memory overhead.

## ◆ e_InsertDocOptionAttachments

PDFDoc.e_InsertDocOptionAttachments
| static

Enumeration for options used for inserting a PDF document to another.

Values of this enumeration can be used alone or in combination.

If set, that means attachments will be inserted to target document as well.

## ◆ e_PermAnnotForm

PDFDoc.e_PermAnnotForm
| static

Operate text annotations and fill in interactive form fields. (Bit 6 in permission value)

If value PDFDoc.e_PermModify is also set, user can create or modify interactive form fields (including signature fields).

## ◆ e_PermAssemble

PDFDoc.e_PermAssemble
| static

Assemble PDF document. (Bit 11 in permission value)

If this value is set, it enables to assemble the document (Insert, rotate, or delete pages and create bookmarks or thumbnail images), regardless if value PDFDoc.e_PermModify is set or not.

## ◆ e_PermExtract

PDFDoc.e_PermExtract
| static

Extract PDF contents. (Bit 5 in permission value)

If this value is set, user can copy or otherwise extract text and graphics from the document by operations other than that controlled by value PDFDoc.e_PermExtractAccess.

## ◆ e_PermExtractAccess

PDFDoc.e_PermExtractAccess
| static

Disabilities support. (Bit 10 in permission value)

If this value is set, user can extract text and graphics in support of accessibility to users with disabilities or for other purposes.

## ◆ e_PermFillForm

PDFDoc.e_PermFillForm
| static

Fill PDF form. (Bit 9 in permission value)

If this value is set, user can fill in interactive form fields (including signature fields), even if value PDFDoc.e_PermAnnotForm is not used.

## ◆ e_PermModify

PDFDoc.e_PermModify
| static

Modify PDF contents. (Bit 4 in permission value)

If this value is set, user can modify contents of PDF document by operations other than those controlled by values PDFDoc.e_PermAnnotForm, PDFDoc.e_PermFillForm and PDFDoc.e_PermAssemble.

## ◆ e_PermPrint

PDFDoc.e_PermPrint
| static

Enumeration for user access permissions in a PDF document.

Values of this enumeration can be used alone or in combination.

Print PDF document with normal mode. (Bit 3 in permission value) If user wants to print a higher quality level of PDF document, please set current value with value PDFDoc.e_PermPrintHigh together.

## ◆ e_PermPrintHigh

PDFDoc.e_PermPrintHigh
| static

Print PDF document with higher qualities. (Bit 12 in permission value)

If this value is not set (and value PDFDoc.e_PermPrint is set), printing is limited to a low-level representation of the appearance, possibly of degraded quality.

## ◆ e_PwdInvalid

PDFDoc.e_PwdInvalid
| static

Enumeration for the type of current used password in a PDF document.

Values of this enumeration should be used alone.

The password is invalid.

## ◆ e_SaveFlagIncremental

PDFDoc.e_SaveFlagIncremental
| static

Save document incrementally.

This can be used alone or be combined with other saving flags except PDFDoc.e_SaveFlagNormal. Especially, if this is combined with PDFDoc.e_SaveFlagNoOriginal, only the increment data will be saved.

## ◆ e_SaveFlagLinearized

PDFDoc.e_SaveFlagLinearized
| static

Save document as a linearized file.

This should be used alone and cannot be used with other saving flags except PDFDoc.e_SaveFlagNoUpdatingMetadataDateTime.. This can only be used for function PDFDoc.SaveAs or PDFDoc.StartSaveAs.

## ◆ e_SaveFlagNoOriginal

PDFDoc.e_SaveFlagNoOriginal
| static

Save document without original data or unchanged objects.

This can be used alone or be combined with other saving flags except PDFDoc.e_SaveFlagNormal. Especially, if this is combined with PDFDoc.e_SaveFlagIncremental, only the increment data will be saved.

## ◆ e_SaveFlagNormal

PDFDoc.e_SaveFlagNormal
| static

Enumeration for PDF document saving flags.

Values of this enumeration can be used alone or in combination.

Save document normally, without using any special flag.

This can only be combined with flag PDFDoc.e_SaveFlagNoUpdatingMetadataDateTime.

## ◆ e_SaveFlagNoUpdatingMetadataDateTime

PDFDoc.e_SaveFlagNoUpdatingMetadataDateTime
| static

Save document without updating metadata "ModDate" and "CreationDate".

This can be used alone or be combined with other saving flags. This can only be used for function PDFDoc.SaveAs and PDFDoc.StartSaveAs.

## ◆ e_SaveFlagRemoveRedundantObjects

PDFDoc.e_SaveFlagRemoveRedundantObjects
| static

Save document with removing redundant PDF objects.

This can be used alone or be combined with PDFDoc.e_SaveFlagNoOriginal, PDFDoc.e_SaveFlagXRefStream or PDFDoc.e_SaveFlagNoUpdatingMetadataDateTime. This can only be used for function PDFDoc.SaveAs or PDFDoc.StartSaveAs.

## ◆ e_SaveFlagXRefStream

PDFDoc.e_SaveFlagXRefStream
| static

Save document by using XRef stream.

This can be used alone or be combined with other saving flags except PDFDoc.e_SaveFlagNormal.

## ◆ e_WrapperNone

PDFDoc.e_WrapperNone
| static

Enumeration for wrapper type.

Values of this enumeration should be used alone.

Normal document.